/*
 *	Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2005-11-30
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License as published by the
 *	Free Software Foundation; either version 2 of the License, or (at your
 *	option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
*/

package spirals.motol.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Frame with information about application</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.1.3
 */
public class MainFrame_AboutBox
    extends JDialog implements ActionListener {
  private MainFrame mf;
  private JButton button = new JButton("OK");

  private ImageIcon logo = new ImageIcon(MainFrame_AboutBox.class.getResource("/res/logo.gif"));
  private String product = "<html><h2>Parkinson Disease Database</h2></html>";
  private String version = "version 1.1.3";
  private String copyright = "Copyright (c) 2005 Jan Doleel";
  private String place = "VUT FEL, Prague";
  private String url = "http://www.eithel.net/download/ui/spiral";
  private String comments = "<html></html>";

  /**
   * create about frame for parent MainFrame
   */
  public MainFrame_AboutBox(MainFrame parent) {
    super(parent);
    this.mf = parent;
    try {
      setDefaultCloseOperation(DISPOSE_ON_CLOSE);
      jbInit();
    }
    catch (Exception exception) {
      exception.printStackTrace();
    }
  }

  /**
   * Component initialization.
   * @throws java.lang.Exception
   */
  private void jbInit() throws Exception {
    setTitle("About");
    setResizable(false);
    JPanel contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.PAGE_AXIS));
    contentPane.setAlignmentX(CENTER_ALIGNMENT);

    MyLabel icon = new MyLabel(mf, "");
    icon.setIcon(logo);
    contentPane.add(icon);
    contentPane.add(new MyLabel(mf, product));
    contentPane.add(new MyLabel(mf, version));
    contentPane.add(new MyLabel(mf, copyright));
    contentPane.add(new MyLabel(mf, place));
    MyLabel link = new MyLabel(mf, url);
    link.setForeground(Color.blue);
    contentPane.add(link);
    contentPane.add(new MyLabel(mf, comments));

    button.addActionListener(this);
    button.setAlignmentX(0.5f);
    contentPane.add(button);
  }

  /**
   * Close the dialog on a button event.
   */
  public void actionPerformed(ActionEvent actionEvent) {
    if (actionEvent.getSource() == button) {
      dispose();
    }
  }
}

class MyLabel extends JLabel {
  public MyLabel(MainFrame mf, String text) {
    super(text);
    this.setVerticalTextPosition(SwingConstants.BOTTOM);
    this.setHorizontalTextPosition(SwingConstants.CENTER);
    this.setFont(mf.getSmallFont());
    this.setAlignmentX(0.5f);
    this.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 10));
  }
}
